﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;

namespace TestKmlMapSuiteCore
{
    class KmlMapEngine : MapEngine
    {
        KmlGeoCanvas kmlGeoCanvas;

        public KmlMapEngine()
        {
            kmlGeoCanvas = new KmlGeoCanvas();
        }

        public void DrawStaticLayers(StringBuilder kmlStringBuilder, GeographyUnit geographyUnit)
        {
            LayersDrawingEventArgs layersDrawingEventArgs = new LayersDrawingEventArgs(StaticLayers, CurrentExtent, kmlStringBuilder);
            OnLayersDrawing(layersDrawingEventArgs);
            if (!layersDrawingEventArgs.Cancel)
            {
                foreach (Layer layer in StaticLayers)
                {
                    LayerDrawingEventArgs layerDrawingEventArgs = new LayerDrawingEventArgs(layer, CurrentExtent, kmlStringBuilder);
                    OnLayerDrawing(layerDrawingEventArgs);
                    if (!layerDrawingEventArgs.Cancel)
                    {
                        kmlGeoCanvas.BeginDrawing(kmlStringBuilder, CurrentExtent, geographyUnit);
                        layer.Draw(kmlGeoCanvas, new Collection<SimpleCandidate>());
                    }
                    OnLayerDrawn(new LayerDrawnEventArgs(layer, CurrentExtent, kmlStringBuilder));
                }
            }
            OnLayersDrawn(new LayersDrawnEventArgs(StaticLayers, CurrentExtent, kmlStringBuilder));
            kmlGeoCanvas.EndDrawing();
        }
    }
}
